/*
  This code was written by Raymond Chi-Wing Wong.
  Please read the following.

    Raymond Chi-Wing Wong, Yufei Tao, Ada Wai-Chee Fu and Xiaokui Xiao. 
    "On Efficient Spatial Matching", 
    the 33rd International Conference on Very Large Data Bases (VLDB'07), 
    Vienna, Austria on 23-28 Sept, 2007 

*/

#ifndef POINT_H
#define POINT_H

#include "rtree.h"

struct point_s
{
	int id;
	int weight;
	R_TYPE *content;
};

typedef struct point_s point;

struct pointList_s
{
	int noOfPoint;
	int noOfRemain;

	point **list;
};

typedef struct pointList_s pointList;

struct twoData_s
{
	pointList *O;
	pointList *P;
};

typedef struct twoData_s twoData;

pointList *pointList_new();
point *point_new(int noOfDim);

twoData *twoData_new();

pointList *pointList_clone(pointList *aPointList, int noOfDim);

point *twoData_getOPoint(twoData *aTwoData, int oid);
point *twoData_getPPoint(twoData *aTwoData, int pid);

void twoData_decrementO(twoData *aTwoData);
void twoData_decrementP(twoData *aTwoData);

int twoData_oIsEmpty(twoData *aTwoData);
int twoData_pIsEmpty(twoData *aTwoData);

twoData *twoData_clone(twoData *aTwoData, int noOfDim);

#endif

